abstract sig FSObject {
  parent: lone FSObject
}

sig File extends FSObject {}

sig Dir extends FSObject {
  contents: set FSObject
}

one sig Root extends Dir {}

pred isLeave[f: FSObject] {
  f in File || no f.contents
}

run isLeave 

fun leaves[f: FSObject]: set FSObject {
  { x: f.*contents | isLeave[x] }
}

run leaves

