open util/boolean 

// The root of the class hierarchy
abstract sig Object {}

sig Array extends Object  {
  length: Int,
  data: { i: Int | 0 <= i && i < length } -> lone Object
}
{
  0 <= length
}

sig List extends Object {
  elems: Array,   // inv1
  len: Int,
  shared: Bool
}
{
  0 <= len && len <= elems.length  // inv 5
}

fact inv3 {
  all disj l1, l2: List | l1.elems = l2.elems => isTrue[l1.shared]
}

fact inv4 {
  all l: List | no a: Array, i: Int | a.data[ i ] = l.elems
}

pred show {
  some  l: List | isFalse[l.shared] &&
  some  l: List | isTrue[l.shared] &&
  some  disj l1, l2: List | l1.elems = l2.elems
}

run show for 7 but 3 List
